VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsD2Items"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False

Option Explicit

Public Item_Count As Integer

Private m_bMessageID As Long
Private m_bActionID As Long
Private m_bMessageLen As Long
Private m_ItemType As Long
Private m_ItemID As Long



Private m_isMiscItem As Boolean
Private m_isEar As Boolean
Private m_isInSocket As Boolean
Private m_isSocketed As Boolean
Private m_isIdentified As Boolean

Private m_isQuestItem As Boolean


Private m_sBaseName As String

Private m_iDefense As Long
Private m_iDurabilityMax As Long
Private m_iDurabilityCur As Long


Private Const TYPE_WEAPON As Byte = &H5
Private Const TYPE_BOW As Byte = &H6
Private Const TYPE_HELM As Byte = &H0
Private Const TYPE_ARMOR As Byte = &H1
Private Const TYPE_SHIELD As Byte = &H7
Private Const TYPE_PHEAD As Byte = &HA
Private Const TYPE_MISC As Byte = &H10

Private Const POS_STORED As Byte = &H0
Private Const POS_WORN As Byte = &H2
Private Const POS_BELT As Byte = &H3
Private Const POS_GROUND As Byte = &H4
Private Const POS_TOHAND As Byte = &H5
Private Const POS_INSOCKET As Byte = &H6

Private Const BOBY_NOTWORN As Byte = &H0
Private Const BODY_HEAD As Byte = &H1
Private Const BODY_AMMY As Byte = &H2
Private Const BODY_BODY As Byte = &H3
Private Const BODY_WEAPON As Byte = &H4
Private Const BODY_SHEILD As Byte = &H5
Private Const BODY_LRING As Byte = &H6
Private Const BODY_RRING As Byte = &H7
Private Const BODY_BELT As Byte = &H8
Private Const BODY_BOOT As Byte = &H9
Private Const BODY_GLOVES As Byte = &HA
Private Const BODY_WEAPON2 As Byte = &HB
Private Const BODY_SHEILD2 As Byte = &HC

Private Const MSG_INSTORE As Byte = &HB
Private Const MSG_BOUGHT As Byte = &HC
Private Const MSG_SWAPINV As Byte = &HD
Private Const MSG_TOBELT As Byte = &HE
Private Const MSG_FROMBELT As Byte = &HF
Private Const MSG_SWAPBELT As Byte = &H10

Private Const ITEM_WEARING As Byte = &H0
Private Const ITEM_INV As Byte = &H1
Private Const ITEM_CUBE As Byte = &H4
Private Const ITEM_STASH As Byte = &H5


Private Const QUAL_CRAFTED = &H0
Private Const QUAL_INFERIOR = &H1
Private Const QUAL_NORMAL = &H2
Private Const QUAL_SUPERIOR = &H3
Private Const QUAL_MAGIC = &H4
Private Const QUAL_SET = &H5
Private Const QUAL_RARE = &H6
Private Const QUAL_UNIQUE = &H7

Private m_isUnknown(10) As Long
Private m_isillegalInv As Boolean
Private m_isDuplicated As Boolean
Private m_isIllegalEquip As Boolean
Private m_earStructure As Long
Private m_isStarterItem As Boolean
Private m_isSimpleStruc As Boolean
Private m_isEthereal As Boolean
Private m_isInscribed As Boolean
Private m_isRuneword As Boolean
Private m_itemVersion As Long
Private m_itemLocation As Long
Private m_posOnBody As Long
Private m_gridCol As Long
Private m_gridRow As Long
Private m_storedIn As Long


Private m_ItemCode As String

Private m_numOfGems As Long
Private m_Guid As Long
Private m_DropLevel As Long
Private m_Quality As Long
Private m_varGraphic As Boolean
Private m_classInfo As Boolean
Private m_uniqueID As Long
Private m_timeStamp As Long
Private m_Defence As Long
Private m_goldSize As Long
Private m_goldAmount As Long
Private m_hasMagicStats As Boolean
Private m_Quantity As Long

Private m_pArmor As Long
Private m_pWeapon As Long
Private m_pMisc As Long

Private m_OwnerAction As Long
Private m_OwnerID As Long

Private iRunePrefix As Long
Private iRuneSuffix As Long

Private iPrefix As Long
Private iSuffix As Long

Private RarePrefix As Long
Private RareSuffix As Long

Private setID As Long

Private m_MaxDurability As Integer
Private m_Durability As Integer

Private m_MagicPrefixName As String
Private m_MagicSuffixName As String

Private m_ItemBits As New clsBitFields

Public Sub ParseItemDrop(Packet As String, Length As Long)
    
    
    m_ItemBits.BitFields Packet, Length
    
    
    
    '//get the common bits
    m_bMessageID = m_ItemBits.GetField(8, "MessageID")
    m_bActionID = m_ItemBits.GetField(8, "ActionID")
    m_bMessageLen = m_ItemBits.GetField(8, "MessageLen")
    m_ItemType = m_ItemBits.GetField(8, "ItemType")
    m_ItemID = m_ItemBits.GetField(32, "ItemID")
    
    '//9D Only, get the owner ID
    If m_bMessageID = &H9D Then
        m_OwnerAction = m_ItemBits.GetField(8, "OwnerAction")
        m_OwnerID = m_ItemBits.GetField(32, "OwnerID")
    End If
        
    '//parse flag info
    '// * = not sure what they mean
    m_isQuestItem = m_ItemBits.GetField(1, "QuestItem") '*
    m_isUnknown(0) = m_ItemBits.GetField(3, "Unknown") '*
    m_isIdentified = m_ItemBits.GetField(1, "isIdentified")
    m_isUnknown(1) = m_ItemBits.GetField(3, "Unknown") '*
    m_isillegalInv = m_ItemBits.GetField(1, "IllegalInv")
    m_isUnknown(2) = m_ItemBits.GetField(1, "Unknown") '*
    m_isDuplicated = m_ItemBits.GetField(1, "IsDuplicated") '*
    m_isSocketed = m_ItemBits.GetField(1, "IsSocketed")
    m_isUnknown(3) = m_ItemBits.GetField(2, "Unknown") '*
    m_isIllegalEquip = m_ItemBits.GetField(1, "isIllegalEquip")
    m_isUnknown(4) = m_ItemBits.GetField(1, "Unknown")
    m_earStructure = m_ItemBits.GetField(1, "earStructure")
    m_isStarterItem = m_ItemBits.GetField(1, "isStarterItem")
    m_isUnknown(5) = m_ItemBits.GetField(2, "Unknown") '*
    m_isUnknown(6) = m_ItemBits.GetField(1, "Unknown") '*
    m_isSimpleStruc = m_ItemBits.GetField(1, "isSimpleStruc")
    m_isEthereal = m_ItemBits.GetField(1, "isEthereal")
    m_hasMagicStats = m_ItemBits.GetField(1, "hasMagicStats")
    m_isInscribed = m_ItemBits.GetField(1, "isInscribed")
    m_isUnknown(7) = m_ItemBits.GetField(1, "Unknown") '*
    m_isRuneword = m_ItemBits.GetField(1, "isRuneword")
    
    '//parse item version
    m_isUnknown(8) = m_ItemBits.GetField(5, "Unknown") '*
    m_itemVersion = m_ItemBits.GetField(8, "ItemVersion")
    m_isUnknown(9) = m_ItemBits.GetField(2, "Unknown") '*
    
    '//parse item location
    m_itemLocation = m_ItemBits.GetField(3, "ItemLocation")
    m_posOnBody = m_ItemBits.GetField(4, "PosOnBody")
    m_gridCol = m_ItemBits.GetField(4, "GridCol")
    m_gridRow = m_ItemBits.GetField(4, "GridRow")
    m_storedIn = m_ItemBits.GetField(3, "storedIn")
    
    
    '//if the item is an ear then the item code is "ear"
    If m_isEar Then
            m_Quality = 1 'Normal
            m_ItemCode = "ear"
        Else
            GetBaseItem Packet
    End If
        
    
    If m_isEar Then
            'Need to get the character's name, class and level
            'class = 3 bits
            'level = 7 bits?
            'name = 15 chars max
    
        ElseIf m_isMiscItem Then
            GetMiscAttributes
            'GetBaseAttributes
    Else
    
        m_numOfGems = m_ItemBits.GetField(3, "numOfGems")
        m_DropLevel = m_ItemBits.GetField(7, "DropLevel")
        m_Quality = m_ItemBits.GetField(4, "Quality")
    
            
    End If
    
        m_varGraphic = m_ItemBits.GetField(1, "varGraphic") '*
        m_classInfo = m_ItemBits.GetField(1, "ClassInfo") '*
            

        If m_isIdentified Then
            Select Case m_Quality
                Case QUAL_CRAFTED: GetRareAttributes
                Case QUAL_INFERIOR: GetInferiorAttributes
                Case QUAL_NORMAL: '
                Case QUAL_SUPERIOR: GetSuperiorAttributes
                Case QUAL_MAGIC: GetMagicAttributes
                Case QUAL_SET: GetSetAttributes
                Case QUAL_RARE: GetRareAttributes
                Case QUAL_UNIQUE: GetUniqueAttributes
                 Case Else:
            End Select
        End If
        
        '//get the runeword
        If m_isRuneword Then
            iRunePrefix = m_ItemBits.GetField(8, "iRunePrefix")
            iRuneSuffix = m_ItemBits.GetField(8, "iRuneSuffix")
        End If

        
        '// if the item is personalized, then get the name
        If m_isInscribed Then
            '
        End If

    AddChat "An Item as been located - ItemCode=" & m_ItemCode & " - Quality=" & m_Quality & " - ItemLevel= " & m_DropLevel & vbCrLf, vbTeal
End Sub

Public Sub GetBaseItem(Data As String)
    '//get the item code
    m_ItemCode = m_ItemBits.GetField(32, "ItemCode") '*
    m_ItemCode = Hex(m_ItemCode)
    m_ItemCode = StrReverse(ToStr(m_ItemCode))
    m_ItemCode = Replace(m_ItemCode, " ", "")
    
End Sub



Private Sub GetMiscAttributes()

    If m_ItemCode = "gld" Then
        m_goldSize = m_ItemBits.GetField(1, "GoldSize")
            If Hex(m_goldSize) = &H0 Then
                m_goldAmount = m_ItemBits.GetField(12, "GoldAmount")
                    Else
                m_goldAmount = m_ItemBits.GetField(32, "GoldAmount")
            End If
    End If
    
End Sub

Private Sub GetUniqueAttributes()

    m_uniqueID = m_ItemBits.GetField(12, "UniqueID")
    
End Sub


Private Sub GetMagicAttributes()

    iPrefix = m_ItemBits.GetField(3, "iPrefix") 'extra 3 bits..
    iPrefix = m_ItemBits.GetField(11, "iPrefix")
    iSuffix = m_ItemBits.GetField(11, "iSuffix")
    
End Sub

Private Sub GetSetAttributes()

    setID = m_ItemBits.GetField(12, "SetID")
    
End Sub

Private Sub GetRareAttributes()
    
    'needs testing
    RarePrefix = m_ItemBits.GetField(8, "Rare Prefix") - 155
    RareSuffix = m_ItemBits.GetField(8, "Rare Suffix")

End Sub

Private Sub GetInferiorAttributes()
    Dim iQualityType As Long
    
        iQualityType = m_ItemBits.GetField(3, "iQualityType")
        
    'Select Case iQualityType
    '    Case 0: m_sBaseName = "Crude " + m_sBaseName
    '    Case 1: m_sBaseName = "Cracked " + m_sBaseName
    '    Case 2: m_sBaseName = "Damaged " + m_sBaseName
    '    Case 3: m_sBaseName = "Low Quality " + m_sBaseName
    'End Select
    
End Sub

Private Sub GetSuperiorAttributes()
    Dim iQualityType As Long
        
        iQualityType = m_ItemBits.GetField(3, "iQualityType")
        
    'm_sBaseName = "Superior " + m_sBaseName ;
End Sub
