VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsD2Packets"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Public Sub Parse(ByVal Data As String)
 On Error Resume Next
 
    Dim PacketID As String, pID As Integer
    Dim PacketSize As Long
    
   
    PacketSize = D2GS_PackLen(Asc(Mid(Data, 1, 1)))
    
        If PacketSize = -1 Then
            PacketSize = GetVerySize(Data)
        End If
            
        If Len(Data) <> PacketSize Then
            Exit Sub
        End If
    
    
    pID = Asc(Left$(Data, 1))
    
    If pID <= &HF Then
        PacketID = "0x0" & Hex(pID)
    
    Else
        PacketID = "0x" & Hex(pID)
    End If
    
    'The header is needed.
    If pID = &H9C Or pID = &H9D Then
        CallByName Me, "packet_" & PacketID, VbMethod, Data
            Exit Sub
    End If
    
    
    CallByName Me, "packet_" & PacketID, VbMethod, Mid$(Data, 2)
    
End Sub

Public Sub packet_0x07(Data As String)

    RoomInfo.CurrentLevel = RoomInfo.LevelName((Asc(Mid(Data, 5, 1))))

    If Not mInfo.AreaLoc = RoomInfo.CurrentLevel Then
        AddChat "You are currently in: " & RoomInfo.LevelName((Asc(Mid(Data, 5, 1)))) & vbCrLf, vbGrey
            mInfo.AreaLoc = RoomInfo.LevelName((Asc(Mid(Data, 5, 1))))
    End If
End Sub

Public Sub packet_0x0B(Data As String)
    mInfo.ID = GetDWORD(Mid(Data, 2))
End Sub

Public Sub packet_0x15(Data As String)

    Dim ObjectID As Long
    Dim ObjectType As Byte
    Dim LocationX As Long
    Dim LocationY As Long
    
        ObjectType = Asc(Mid(Data, 1, 1))
        ObjectID = GetDWORD(Mid(Data, 2, 4))
        LocationX = GetWORD(Mid(Data, 6, 2))
        LocationY = GetWORD(Mid(Data, 8, 2))
        
        
        If ObjectID = mInfo.ID Then
                'We got our location
                mInfo.LocX = LocationX
                mInfo.LocY = LocationY
                
                AddChat "Current Location is: X=" & mInfo.LocX & " - Y=" & mInfo.LocY & vbCrLf, vbGreen

        End If
        
        
End Sub

Public Sub packet_0x59(Data As String)

    Dim cID As String, cClass As Byte, cName As String, LocX As Long, LocY As Long
        
        cID = GetDWORD(Data)
        cClass = Asc(Mid(Data, 5, 1))
        cName = GetNTString(Mid(Data, 6, 16))
        
        LocX = GetWORD(Mid(Data, 22))
        LocY = GetWORD(Mid(Data, 24))
        
        If cName = mInfo.Name Then
            
            'Lets get our info :)
            mInfo.ID = cID
            mInfo.Class = cClass

            
            AddChat "Entered World | ID=" & mInfo.ID & " | Name=" & mInfo.Name & " | Class=" _
                & getPlayerClass(mInfo.Class) & vbCrLf, vbGreen
        
        End If
        
End Sub

Public Sub packet_0x23(Data As String)

    Dim PlaceID As Long
    Dim SkillID As Long
    Dim PlayerID As Long
    Dim Placement As String
    
        PlayerID = GetDWORD(Mid(Data, 2))
        PlaceID = Asc(Mid(Data, 6))
        SkillID = GetWORD(Mid(Data, 7))
        
            If mInfo.ID = PlayerID Then
                If PlaceID = &H0 Then
                    Placement = "right"
                        mInfo.RightSkill = SkillID
                Else
                    Placement = "left"
                        mInfo.LeftSkill = SkillID
                End If
            
                AddChat "Current " & Placement & " Skill is " & SkillNames(SkillID) & vbCrLf, vbGreen
            End If
End Sub

Public Sub packet_0x60(Data As String)
Dim PortalID As Long
Dim AreaID As Long
    
    AreaID = Asc(Mid(Data, 2))
    PortalID = GetDWORD(Mid(Data, 3))
    
    
    AddChat "A Portal has been located to " & RoomInfo.LevelName(AreaID) & " - ID of portal is: " & PortalID & vbCrLf, vbGrey

End Sub

Public Sub packet_0x94(Data As String)

    Dim SkillCount As Byte
    Dim PlayerID As Long
    Dim I As Integer
    Dim Skilllevel As Integer
    Dim gsSkills(1 To 40) As Long
    
    SkillCount = Asc(Mid(Data, 1, 1))
    PlayerID = GetDWORD(Mid(Data, 2))
    
        Data = Mid(Data, 6)
    
    AddChat "Current skills: " & vbCrLf, vbGrey
    
        For I = 1 To SkillCount
            
            If Asc(Mid(Data, 1, 2)) <= 157 Then
                gsSkills(I) = Asc(Mid(Data, 1, 2))
                Skilllevel = Asc(Mid(Data, 3, 1))
                AddChat "Skill:" & I & " " & SkillNames(gsSkills(I)) & " Level: " & Skilllevel & vbCrLf, vbDGreen
            End If
            
            Data = Mid(Data, 4)
            
        Next I
    
    
End Sub

Public Sub packet_0x9D(Data As String)
    Dim D2Item As New clsD2Items
        D2Item.ParseItemDrop Data, Len(Data)
End Sub


Public Sub packet_0x9C(Data As String)
    Dim D2Item As New clsD2Items
        D2Item.ParseItemDrop Data, Len(Data)
End Sub

Public Sub packet_0xac(Data As String)
Dim ObjectID As Long
Dim ComID As Long
Dim LocX As Long
Dim LocY As Long
Dim NPC_Name As String

    ObjectID = GetDWORD(Data)
    ComID = GetWORD(Mid(Data, 5))
    LocX = GetWORD(Mid(Data, 7))
    LocY = GetWORD(Mid(Data, 9))
    
    With xEntity(ComID)
        .eLocationX = LocX
        .eLocationY = LocY
        .ID = ObjectID
    End With
    
    
            
     AddChat xEntity(ComID).Name & " has come into view. X=" & xEntity(ComID).eLocationX & " - " _
        & "Y=" & xEntity(ComID).eLocationX & " | ID=" & xEntity(ComID).ID & " | Class=" & xEntity(ComID).eType _
            & vbCrLf, vbYellow

End Sub

